package example.org.cuentanos;

import android.app.Activity;
import android.content.Context;

/**
 * Created by Jota on 04/11/2015.
 */
public class IncidenciaDataClass {
    Integer _id=null;
    Integer enviado=0;

    private String ErrorMsg="";



public  enum Acciones
    {Nueva,Ver}

    private Integer categoria;
    private Integer subcategoria;
    private String dni;
    private String email;
    private String observacion;
    private String direccion;
    private Double  longitud;
    private Double  latitud;
    private String foto;
    private String  telefono;
    private String  fecha;
    private String Nombre;

    private String ticketCentral="";
    private Integer procesado=0;


    public String getTicketCentral() {
        return ticketCentral;
    }

    public void setTicketCentral(String ticketCentral) {
        this.ticketCentral = ticketCentral;
    }

    public Integer isProcesado() {
        return procesado;
    }

    public void setProcesado(Integer procesado) {
        this.procesado = procesado;
    }

    public Integer get_id() {
        return _id;
    }

    public void set_id(Integer _id) {
        this._id = _id;
    }

    public Integer getEnviado() {
        return enviado;
    }

    public void setEnviado(Integer enviado) {
        this.enviado = enviado;
    }

    public Integer getCategoria() {
        return categoria;
    }

    public void setCategoria(Integer categoria) {
        this.categoria = categoria;
    }

    public Integer getSubcategoria() {
        return subcategoria;
    }

    public void setSubcategoria(Integer subcategoria) {
        this.subcategoria = subcategoria;
    }

    public String getDni() {
        return dni;
    }

    public void setDni(String dni) {
        this.dni = dni;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getObservacion() {
        return observacion;
    }

    public void setObservacion(String observacion) {
        this.observacion = observacion;
    }

    public String getDireccion() {
        return direccion;
    }

    public void setDireccion(String direccion) {
        this.direccion = direccion;
    }

    public Double getLongitud() {
        return longitud;
    }

    public void setLongitud(Double longitud) {
        this.longitud = longitud;
    }

    public Double getLatitud() {
        return latitud;
    }

    public void setLatitud(Double latitud) {
        this.latitud = latitud;
    }

    public String getFoto() {
        return foto;
    }

    public void setFoto(String foto) {
        this.foto = foto;
    }

    public String getTelefono() {
        return telefono;
    }

    public void setTelefono(String telefono) {
        this.telefono = telefono;
    }

    public String   getFecha() {
        return fecha;
    }

    public void setFecha(String   fecha) {
        this.fecha = fecha;
    }

    public String getNombre() {
        return Nombre;
    }

    public void setNombre(String nombre) {
        Nombre = nombre;
    }





    public IncidenciaDataClass()
    {
        this.categoria = -1;
        this.subcategoria = -1;
        this.dni = "";
        this.email = "";
        this.telefono = "";
        this.Nombre="";
        this.observacion = "";
        this.direccion = "";
        this.longitud = null;
        this.latitud = null;
        this.foto = "";
        this.telefono = "";
        this.fecha = "";
        this.procesado=0;
        this.ticketCentral="";
        this.enviado=0;

    }


    public IncidenciaDataClass(Integer ID,Integer categoria, Integer subcategoria,Integer procesado,String ticketCentral, String dni,String Nombre, String email, String observacion, String direccion, Double longitud, Double latitud, String foto, String telefono, String fecha, Integer enviado ) {

        this.categoria = categoria;
        this.subcategoria = subcategoria;
        this.dni = dni;
        this.email = email;
        this.observacion = observacion;
        this.direccion = direccion;
        this.longitud = longitud;
        this.latitud = latitud;
        this.foto = foto;
        this.telefono = telefono;
        this.fecha = fecha;
        this.Nombre=Nombre;
        this.procesado=procesado;
        this.enviado=enviado;
        this.ticketCentral=ticketCentral;
        this._id=ID;

    }

//marca una incicencia como enviada
    public String GetEnviadoUpdatedCommand()
    {

        String resultado="";


        resultado="Update  incidencias Set enviado=1,ticketCental='"+ticketCentral +"' where _id="+ _id.toString();
        return resultado;
    }

    //marca una incicencia como procesada y le coloca el ticket central
    public String GetProcesadoUpdatedCommand()
    {

        String resultado="";


        resultado="Update  incidencias Set procesado=1  where ticketCental='"+ ticketCentral +"'";
        return resultado;
    }




    public static String GetListadoIncidenciasCommand(boolean bEnviada, boolean bProcesado)
    {
        String columnas="";
        String from="";
        String resultado="";

        Integer Enviado=0;
        if(bEnviada) Enviado=1;
        Integer procesado=0;
        if(bProcesado) procesado=1;


        columnas="select i._id ,i.categoria,i.subcategoria,i.procesado,i.ticketCental ,i.dni,i.Nombre,i.email,i.observacion,i.direccion,i.longitud,i.latitud,i.foto,i.telefono,i.fecha,i.enviado,c.imagen";
        from=" from incidencias i " +
                "join categorias c " +
            " on " +
                " c._id=i.categoria " +
            " join subcategorias s " +
            " on " +
                "i.subcategoria=s._id " +
        " where " +
            " i.enviado=" +Enviado.toString();

            if(bEnviada)
                from=from+ " and i.procesado=" + procesado.toString();

        return columnas +from;

    }
//lista
    public static String GetListadoIncidenciasCommand()
    {
        String columnas="";
        String from="";
        String idioma="";

        idioma=AppUtils.GetLanguage();

        columnas="select i._id ,i.categoria,i.subcategoria,i.procesado,i.fecha,i.enviado,c.imagen,c.nombre_" + idioma+ " as categoriaNom,s.nombre_" + idioma+ " as subcategoriaNom";
        from=" from incidencias i " +
                "join categorias c " +
                " on " +
                " c._id=i.categoria " +
                " join subcategorias s " +
                " on " +
                "i.subcategoria=s._id " +
                "order by i._id desc";


        return columnas +from;

    }
//detalle
    public static String GetIncidenciabyIDCommand(Integer Id)
    {
        String columnas="";
        String from="";




        columnas="select i._id ,i.categoria,i.subcategoria,i.procesado,i.ticketCental ,i.dni,i.Nombre,i.email,i.observacion,i.direccion,i.longitud,i.latitud,i.foto,i.telefono,i.fecha,i.enviado,c.imagen";
        from=" from incidencias i " +
                "join categorias c " +
                " on " +
                " c._id=i.categoria " +
                " join subcategorias s " +
                " on " +
                "i.subcategoria=s._id " +
                "where i._id=" + Id.toString();


        return columnas +from;

    }





    public String GetInsertCommand()
    {

        String columnas="";
        String valores="";
        String resultado="";

        this._id=null;
        this.enviado=0;

        columnas="(categoria,subcategoria, dni,Nombre,email,observacion,direccion,longitud,latitud,foto,telefono,fecha,enviado,procesado,ticketCental)";
        valores=categoria.toString()+","+subcategoria.toString()+","+"'" +dni+"','"+Nombre + "','" +email+"','"+observacion+"','"+direccion+"',"+longitud.toString()+","+latitud.toString()+",'"+foto+"','" + telefono+"','"+AppUtils.FechaActual() +"',"+enviado.toString()+","+procesado.toString()+",'"+ticketCentral+"'";
        resultado="Insert Into incidencias "+ columnas +" values (" + valores +")";
        return resultado;
    }




    //saca el texto a mostrar o coordenadas o calles
    public String TextoDirección()
    {
        String result="";

        if((this.latitud==null)&&(this.longitud==null))
        {
            result="";
        }
        else
        {
            if(this.direccion.length()==0)
            {
                result="(" + this.latitud.toString() + "," +this.longitud.toString() + ")";
                this.direccion=result;
            }
            else
            {
                result=this.direccion;
            }

        }

        return result;
    }

    public boolean Valida()
    {
        boolean rsult=false;

        if((Nombre.length()>0)&&( email.length()>0)&&( dni.length()>0)&&( telefono.length()>0)&&( observacion.length()>0)&&( direccion.length()>0)&&( foto.length()>0))
        {
            rsult=true;
        }

        return rsult;
    }


    public String  ErrorMsg(Activity activity)
    {

        ErrorMsg= activity.getString(R.string.NoData) + " " +
                (Nombre.length()==0 ? "-" +activity.getString(R.string.pref_title_display_name)  : "") +
                (dni.length()==0 ? "-" +activity.getString(R.string.pref_title_display_DNI)  : "")+
                (email.length()==0 ? "-" +activity.getString(R.string.pref_title_display_Mail)  : "")+
                (telefono.length()==0 ? "-" +activity.getString(R.string.pref_title_display_Phone): "")+
                (observacion.length()==0 ? "-" +activity.getString(R.string.Coment)  : "")+
                (direccion.length()==0 ? "-" +activity.getString(R.string.Direccion)  : "")+
                (foto.length()==0 ? "-" +activity.getString(R.string.foto)  : "");
        return ErrorMsg;
    }

        //devuelve el mensaje de info para incidencias enviadas
    public String GetInfo(Context context)
    {
        String Info="";
        if (enviado==0)
            Info=context.getString(R.string.NoSent);
        else
        if (procesado==0)
            Info=context.getString(R.string.Sent);
        else
            Info=context.getString(R.string.Processed) + " " + ticketCentral;

        return Info;
    }


}
