package example.org.cuentanos;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;

/**
 * Created by Jota on 14/11/2015.
 */
public class SynchAlarm {

    private static PendingIntent pendingIntent;
    public static void ConfiguraServicioAlarmas(Context c)
    {


        long configuracion=-1;
        SharedPreferences pref;
        pref = PreferenceManager.getDefaultSharedPreferences(c);

        String i = pref.getString("sync_frequency", "");
        Log.i("-----Autostart_Cuentame", "SynchAlarm configuracion-->" + i);
        switch (i)
        {
            case "15":
                configuracion= AlarmManager.INTERVAL_FIFTEEN_MINUTES;
                break;
            case "30":
                configuracion=AlarmManager.INTERVAL_HALF_HOUR;
                break;
            case "1":
                configuracion=AlarmManager.INTERVAL_HOUR;
                break;
            case "12":
                configuracion=AlarmManager.INTERVAL_HALF_DAY;
                break;
            case "24":
                configuracion=AlarmManager.INTERVAL_DAY;
                break;



        }

        if(configuracion>0)
        {
            Intent myIntent = new Intent( c, SynchService.class);
            pendingIntent = PendingIntent.getService(c, 0, myIntent, 0);
            Log.i("-----Autostart_Cuentame", "SynchAlarm configuracion-->" + pendingIntent.toString());
            AlarmManager alarmManager = (AlarmManager)c.getSystemService(Context.ALARM_SERVICE);
            alarmManager.cancel(pendingIntent);
            alarmManager.setInexactRepeating(AlarmManager.ELAPSED_REALTIME_WAKEUP,
                    configuracion,
                    configuracion, pendingIntent);

        }




    }




}
