package example.org.cuentanos;

import android.content.Context;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.preference.PreferenceManager;


/**
 * Created by Jota on 13/11/2015.
 */

//gestiona las sincronizaciones
public class SynchManager {





    public static InfoSync Synch(Context context)
    {
        boolean bOk=false;
        InfoSync oInfoSync=new InfoSync();

        if(EsElMomento(context))
        {


            try
            {
                oInfoSync.setEnviados(EnviaIncidencias(context));
                bOk=true;
            }catch (Exception e)
            {
                bOk=false;
            }

            try
            {
                oInfoSync.setRecibidos(RecibeEstadoIncidencias(context));
                bOk=bOk;
            }catch (Exception e)
            {
                bOk=false;
            }

            try
            {
                oInfoSync.setUpdates(UpdateApp(context));
                bOk=bOk;
            }catch (Exception e)
            {
                bOk=false;
            }

        }
        else
        {
            oInfoSync.setbNoEsElMomento(true);

        }

        oInfoSync.setbOk(bOk);
        return oInfoSync;
    }


    private static Integer  EnviaIncidencias(Context context)
    {
        Integer Counter=0;
        Cursor ocursor;
        db_DataAcces odb_DataAcces=new db_DataAcces();
        odb_DataAcces.indicializaBD(context);
        ocursor=odb_DataAcces.getlistadoIncidencias(false,false);

        while(ocursor.moveToNext())
        {


            IncidenciaDataClass ooIncidencia=
                    new IncidenciaDataClass(ocursor.getInt(0),//i._id
                                            ocursor.getInt(1),//categoria
                                            ocursor.getInt(2),//subcategoria
                                            ocursor.getInt(3),//procesado
                                            ocursor.getString(4),//TicketCentral
                                            ocursor.getString(5),//dni
                                            ocursor.getString(6),//Nombre
                                            ocursor.getString(7),//email
                                            ocursor.getString(8),//observacion
                                            ocursor.getString(9),//direccion
                                            ocursor.getDouble(10),//longitud
                                            ocursor.getDouble(11),//latitud
                                            ocursor.getString(12),//foto
                                            ocursor.getString(13),//telefono
                                            ocursor.getString(14),//fecha
                                                    ocursor.getInt(15));//enviado

                if (ProxyWebService.SendNotification(ooIncidencia))
                    {
                        if(odb_DataAcces.CambiaEnviadoIncidencia(ooIncidencia))
                        Counter++;
                    }



        }
        ocursor.close();
        odb_DataAcces.CierraBBDD();
        return Counter;
    }

    private static Integer  RecibeEstadoIncidencias(Context context)
    {

        Integer Counter=0;
        Cursor ocursor;
        db_DataAcces odb_DataAcces=new db_DataAcces();
        odb_DataAcces.indicializaBD(context);
        ocursor=odb_DataAcces.getlistadoIncidencias(true,false);

        while(ocursor.moveToNext())
        {


            IncidenciaDataClass ooIncidencia=
                    new IncidenciaDataClass(ocursor.getInt(0),//i._id
                            ocursor.getInt(1),//categoria
                            ocursor.getInt(2),//subcategoria
                            ocursor.getInt(3),//procesado
                            ocursor.getString(4),//TicketCentral
                            ocursor.getString(5),//dni
                            ocursor.getString(6),//Nombre
                            ocursor.getString(7),//email
                            ocursor.getString(8),//observacion
                            ocursor.getString(9),//direccion
                            ocursor.getDouble(10),//longitud
                            ocursor.getDouble(11),//latitud
                            ocursor.getString(12),//foto
                            ocursor.getString(13),//telefono
                            ocursor.getString(14),//fecha
                            ocursor.getInt(15));//enviado

            if (ProxyWebService.ReciveStatusFromNotification(ooIncidencia)==1)
            {
                if(odb_DataAcces.CambiaProcesadoIncidencia(ooIncidencia))
                    Counter++;
            }



        }
        ocursor.close();
        odb_DataAcces.CierraBBDD();
        return Counter;
    }

    //// TODO: 14/11/2015  se conecta al servidor y obtiene nuevas categorias y subcategorias-->falta controlar la versión 
    private static Integer  UpdateApp(Context context)
    {

        return 0;
    }

//a pesar de que sea hora de sincronizar mira si es coherente en función de las preferencias.
private static boolean EsElMomento(Context context)
{
    boolean bOk=false;

    if(AppUtils.isConnectingToInternet(context)) {

        SharedPreferences pref;
        pref = PreferenceManager.getDefaultSharedPreferences(context);

        String i = pref.getString("sync_Connection", "");

        switch (i)
        {

            case "0"://solo wifi
                bOk=AppUtils.isConnectingByWiFi(context);
                break;

            case "1"://da igual cómo nos conectemos wifi+datos
                bOk=true;
                break;
        }
    }
    return bOk;
}




}


