package example.org.cuentanos;

import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.view.Window;
import android.widget.ImageView;

import java.util.Timer;
import java.util.TimerTask;

/**
 * Created by Jota on 03/11/2015.
 */
public class activity_PhotoSplash extends Activity {  // Set the duration of the splash screen
    private static final long SPLASH_SCREEN_DELAY = 3000;
    Timer timer;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        // Set portrait orientation
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        // Hide title bar
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        setContentView(R.layout.activity_photosplash);

        String Path= getIntent().getExtras().getString("pathPhoto");


        ImageView IVfoto= (ImageView) this.findViewById(R.id.imageView);
        Bitmap bitmap;
        bitmap = BitmapFactory.decodeFile(Path);
        IVfoto.setImageBitmap(bitmap);


        TimerTask task = new TimerTask() {
            @Override
            public void run() {

                finish();
            }
        };

        // Simulate a long loading process on application startup.
        timer = new Timer();
        timer.schedule(task, SPLASH_SCREEN_DELAY);
    }
    @Override protected void onPause() {
        super.onPause();
        timer.cancel();

    }
    @Override protected void onResume() {
        super.onResume();

    }

    @Override protected void onStop() {
        super.onStop();


    }
}
