package example.org.cuentanos;

import android.app.ListActivity;
import android.content.Intent;
import android.database.sqlite.SQLiteCursor;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;

/**
 * Created by Jota on 14/11/2015.
 */
public class activity_Search extends ListActivity {

    private AdaptadorCursorBusquedas adaptador;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_search);

        db_DataAcces odb_DataAcces=new db_DataAcces();
        odb_DataAcces.indicializaBD(this);
        adaptador = new AdaptadorCursorBusquedas(this, odb_DataAcces.getlistadoIncidencias());
        setListAdapter(adaptador);
        odb_DataAcces.CierraBBDD();
    }

    @Override protected void onListItemClick(ListView listView, View view, int position, long id) {
        super.onListItemClick(listView, view, position, id);
        Object o = getListAdapter().getItem(position);

        //columnas="select i._id ,i.categoria,i.subcategoria,i.procesado,i.fecha,i.enviado,c.imagen,c.nombre_" + idioma+ " as categoriaNom,s.nombre_" + idioma+ " as subcategoriaNom";

        Intent intent = new Intent(this, activity_incidencia.class);
        intent.putExtra("_id", ((SQLiteCursor) o).getString(0));
        intent.putExtra("_idCat", ((SQLiteCursor) o).getString(1));
        intent.putExtra("_idSub", ((SQLiteCursor) o).getString(2));
        intent.putExtra("imagen", ((SQLiteCursor) o).getString(6));
        intent.putExtra("nombreCat", ((SQLiteCursor) o).getString(7));
        intent.putExtra("nombreSub", ((SQLiteCursor) o).getString(8));
        intent.putExtra("Accion", IncidenciaDataClass.Acciones.Ver);


        startActivity(intent);
    }

}