package example.org.cuentanos;

import android.app.ListActivity;
import android.content.Intent;
import android.content.res.Resources;
import android.database.sqlite.SQLiteCursor;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;

/**
 * Created by Jota on 04/11/2015.
 */
public class subcategoriaLista  extends ListActivity {

    private AdaptadorCursorSubcategorias adaptador;
    private Integer idCategoria;
    private String NombreCategoria;
    private String NombreImagen;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_subcategoria);
        idCategoria= Integer.parseInt(getIntent().getExtras().getString("_id"));
        NombreCategoria=getIntent().getExtras().getString("nombre");
        NombreImagen=getIntent().getExtras().getString("imagen");

        TextView oText=(TextView)this.findViewById(R.id.Titulo);
        oText.setText("   " + NombreCategoria);



        Resources res = this.getResources();
        int resID = res.getIdentifier(NombreImagen, "drawable", this.getPackageName());
        //Drawable drawable = res.getDrawable(resID );


        oText.setCompoundDrawablesWithIntrinsicBounds( res.getIdentifier(NombreImagen, "drawable", this.getPackageName()), 0, 0, 0);

        db_DataAcces odb_DataAcces=new db_DataAcces();
        odb_DataAcces.indicializaBD(this);
        adaptador = new AdaptadorCursorSubcategorias(this, odb_DataAcces.getlistadoSubCategorias(idCategoria));
        setListAdapter(adaptador);
        odb_DataAcces.CierraBBDD();
    }

    @Override protected void onListItemClick(ListView listView, View view, int position, long id) {
        super.onListItemClick(listView, view, position, id);
        Object o = getListAdapter().getItem(position);


        Intent intent = new Intent(this, activity_incidencia.class);
        intent.putExtra("_idSub", ((SQLiteCursor) o).getString(0));
        intent.putExtra("nombreSub", ((SQLiteCursor) o).getString(1));
        intent.putExtra("_idCat", ((SQLiteCursor) o).getString(2));
        intent.putExtra("nombreCat", NombreCategoria);
        intent.putExtra("imagen", NombreImagen);
        intent.putExtra("Accion", IncidenciaDataClass.Acciones.Nueva);


        startActivity(intent);

    }

}

