package example.org.cuentanos;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.graphics.BitmapFactory;
import android.support.v4.app.NotificationCompat;

/**
 * Created by Jota on 14/11/2015.
 */
public class Notificacion {
    static int ID_NOTIFICACION_CREAR = 1;
    public static void CreaciónNotificacion(Context context,InfoSync oInfo)
    {


        Intent ControlIntent;

        NotificationCompat.Builder notific = new NotificationCompat.Builder(context)
                .setContentTitle(context.getResources().getString(R.string.app_name))
                .setSmallIcon(R.drawable.cuentameicon)
                .setContentText(context.getResources().getString(R.string.SynchNotification))
                .setLargeIcon(BitmapFactory.decodeResource(context.getResources(),R.drawable.cuentameicon))
                .setWhen(System.currentTimeMillis() + 1000 * 60 * 60)
                .setContentInfo(context.getResources().getString(R.string.MoreInfo))
                .setDefaults(Notification.DEFAULT_VIBRATE)
                .setDefaults(Notification.DEFAULT_SOUND)
                .setDefaults(Notification.DEFAULT_LIGHTS)
                .setTicker(context.getResources().getString(R.string.SynchNotification));



        ControlIntent=new Intent(context,Activity_InfoSynch.class);
        ControlIntent.putExtra("enviados", oInfo.getMSGEnviados(context));
        ControlIntent.putExtra("recibidos", oInfo.getMSGRecibidos(context));
        ControlIntent.putExtra("updates", oInfo.getMSGUpdates(context));
        ControlIntent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP | Intent.FLAG_ACTIVITY_CLEAR_TOP);
        PendingIntent pendingNotificationIntent = PendingIntent.getActivity(context,0,ControlIntent,PendingIntent.FLAG_UPDATE_CURRENT);


        PendingIntent intencionPendiente= PendingIntent.getActivity(context, 0, ControlIntent, 0);

        notific.setContentIntent(intencionPendiente);


        String ns = Context.NOTIFICATION_SERVICE;
        NotificationManager nMgr = (NotificationManager) context.getSystemService(ns);
        nMgr.cancel(ID_NOTIFICACION_CREAR);

        NotificationManager notificationManager = (NotificationManager)context.getSystemService(Context.NOTIFICATION_SERVICE);
        notificationManager.notify(ID_NOTIFICACION_CREAR, notific.build());

    }
}
